'
'  rserver.bas
'
'  remote binary data server
'

'
'  Compiler Directives
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#Compile Exe
#Dim All

'
'  Included files
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#Include "WIN32API.INC"
#Include "WSCONST.INC"
#Include "RSERVER.INC"

'
'  Constants
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

%LOG_DETAILED = %False

'- Main Screen
%labIP      = 801
%labPort    = 802
%labDate    = 803
%labHits    = 804
%labActive  = 805
%labAction  = 806
%btnSetup    = 807


'
'  Globals
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Global gDlgMain As Long
Global gLog  As Long
Global gSock() As Long
Global gActive As Long
Global gHits As Long
Global gPort As Long

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function FormatIP(RawAddr As Long) As String

   Dim sAddr As String

   sAddr = Mkl$(RawAddr)
   Function = Format$(Asc(Mid$(sAddr, 1, 1))) + "." + _
              Format$(Asc(Mid$(sAddr, 2, 1))) + "." + _
              Format$(Asc(Mid$(sAddr, 3, 1))) + "." + _
              Format$(Asc(Mid$(sAddr, 4, 1)))
End Function

'
'  LogEvent
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub LogEvent(ByVal buffer As String)

   Print #gLog, Date$ + " " + Time$ + " " + Buffer

End Sub

'
'  DisplayEvent
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub DisplayEvent(ByVal buffer As String)

   gHits = gHits + 1
   If gHits > 2000000000 Then
      gHits = 1
   End If

   Control Set Text gDlgMain, %labAction, Time$ + "  " + Buffer
   Control Set Text gDlgMain, %labActive, Format$(gActive)
   Control Set Text gDlgMain, %labHits, Format$(gHits)

End Sub


'
'  DlgProc
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Callback Function DlgProc

   Dim i As Long
   Dim iFound As Long
   Dim iLen As Long
   Dim iCurrentSocket As Long
   Dim iFileLen As Long
   Dim iCount As Long

   Dim zFile As Asciiz * 300
   Dim zField As Asciiz * 300
   Dim zData As Asciiz * 300

   Dim sPort As String
   Dim sData As String
   Dim sReturn As String
   Dim sCommand As String
   Dim sHost As String
   Dim sInBuffer As String
   Dim sBuffer As String

   Dim rIn As XFER_BUFFER_TYPE
   Dim rOut As XFER_BUFFER_TYPE

   Static Buffer    As String
   Static BufLen    As Long
   Static hSock     As Long

   Select Case CbMsg

      Case %WM_INITDIALOG

         hSock = FreeFile
         Tcp Open Server Port gPort As hSock
         If Err Then
            Buffer = "Couldn't create socket!"
         Else
            Tcp Notify hSock, Accept To gDlgMain As %TCP_CONNECT
            Buffer = "Connected to Port " + Format$(gPort)
         End If
         LogEvent Buffer
         Function = 1

      Case %TCP_CONNECT

         '- wparam contains the handle of the socket (FileAttr(hSock, 2) from accept event)
         Select Case LoWrd(CbLParam)

            Case %FD_ACCEPT
               iFound = 0
               For i = 1 To %MAX_CONNECTIONS
                  If gSock(i) = %INVALID_SOCKET Then
                     gSock(i) = FreeFile
                     Tcp Accept hSock As gSock(i)
                     Tcp Notify gSock(i), Recv Close To gDlgMain As %TCP_CONNECT
                     DisplayEvent "FD_ACCEPT: " + Str$(gSock(i)) + " " + Str$(FileAttr(gSock(i), 2))
                     LogEvent "CONNECT"
                     gActive = gActive + 1
                     Exit For
                  End If
               Next i

            Case %FD_READ

               '- Find out which socket is
               '  sending data. This is the
               '  handle - passed in CbWParam
               '
               iCurrentSocket = %INVALID_SOCKET
               For i = 1 To %MAX_CONNECTIONS
                  If FileAttr(gSock(i), 2) = CbWParam Then
                     iCurrentSocket = gSock(i)
                     Exit For
                  End If
               Next i

               If iCurrentSocket = %INVALID_SOCKET Then
                  LogEvent "FD_READ Error!"
                  DisplayEvent "* FD_READ Error!"

               Else
                  Tcp Recv iCurrentSocket, Len(rIn), buffer
                  Lset rIn = buffer

                  '- Get the variable portion of the buffer
                  If rIn.iDataLen > 0 Then
                     Tcp Recv iCurrentSocket, rIn.iDataLen, sInBuffer
                  End If

                  Select Case rIn.iCommand

                     '-------- OPEN FILE FOR SHARED ACCESS
                     Case %RSERVER_OPEN_FILE

                        '- The length of the file name is the first
                        '  two bytes (integer) after the structure.
                        '  The file name follows it's length
                        '
                        zFile = Mid$(sInBuffer, 3, Cvi(Mid$(sInBuffer, 1, 2)))
                        LogEvent "OPEN " + Trim$(zFile) + " AS " + Format$(CbWParam)
                        DisplayEvent "Open File " + zFile

                        '- Open the file. If there's an error, the error
                        '  is stored in the iResult member. Otherwise,
                        '  the file handle is given to the iFile member.
                        '
                        On Error Resume Next
                        rOut.iFile = FreeFile
                        Open zFile For Binary Shared As #rOut.iFile
                        If Err Then
                           rOut.iFile = 0
                        End If
                        rOut.iResult = Err
                        rOut.iDataLen = 0

                        '- Send back the results structure
                        sReturn = Space$(Len(rOut))
                        Lset sReturn = rOut
                        Tcp Send iCurrentSocket, sReturn

                     '-------- CLOSE FILE
                     Case %RSERVER_CLOSE_FILE
                        LogEvent "CLOSE FILE " + Format$(CbWParam)
                        DisplayEvent "CLOSE " + Format$(CbWParam)
                        Close #rIn.iFile
                        rOut.iResult = 0
                        rOut.iDataLen = 0
                        rOut.iFile = 0
                        sReturn = Space$(Len(rOut))
                        Lset sReturn = rOut
                        Tcp Send iCurrentSocket, sReturn

                     '-------- GET DATA FROM FILE
                     Case %RSERVER_GET
                        DisplayEvent "GET " + Format$(CbWParam)

                        '- How much data do they want?
                        iLen = Cvl(Left$(sInBuffer, 4))

                        '- Retrieve the data from the file
                        On Error Resume Next
                        sBuffer = Space$(iLen)
                        Get #rIn.iFile,, sBuffer
                        If Err Then
                           sBuffer = ""
                           rOut.iDataLen = 0
                        Else
                           rOut.iDataLen = Len(sBuffer)
                        End If
                        rOut.iResult = Err
                        rOut.iFile = rIn.iFile

                        '- Send back the response with the data
                        sReturn = Space$(Len(rOut))
                        Lset sReturn = rOut
                        sReturn = sReturn + sBuffer

                        Tcp Send iCurrentSocket, sReturn

                     '-------- WRITE DATA TO FILE
                     Case %RSERVER_PUT

                        DisplayEvent "PUT " + Format$(CbWParam)
                        On Error Resume Next
                        Put #rIn.iFile,, sInBuffer
                        rOut.iResult = Err
                        rOut.iFile = rIn.iFile
                        rOut.iDataLen = 0
                        sReturn = Space$(Len(rOut))
                        Lset sReturn = rOut
                        Tcp Send iCurrentSocket, sReturn

                     '-------- SEEK A POSITION IN THE FILE
                     Case %RSERVER_SEEK
                        DisplayEvent "SEEK " + Format$(CbWParam)
                        On Error Resume Next
                        Seek #rIn.iFile, Cvl(Left$(sInBuffer, 4))
                        rOut.iFile = rIn.iFile
                        rOut.iResult = Err
                        rOut.iDataLen = 0
                        sReturn = Space$(Len(rOut))
                        Lset sReturn = rOut
                        Tcp Send iCurrentSocket, sReturn

                     '-------- GET LENGTH OF THE FILE
                     Case %RSERVER_LOF
                        DisplayEvent "LOF " + Format$(CbWParam)
                        On Error Resume Next
                        i = Lof(rIn.iFile)
                        If Err Then
                           rOut.iDataLen = 0
                           sBuffer = ""
                        Else
                           rOut.iDataLen = 4
                           sBuffer = Mkl$(i)
                        End If
                        rOut.iFile = rIn.iFile
                        rOut.iResult = Err
                        sReturn = Space$(Len(rOut))
                        Lset sReturn = rOut
                        sReturn = sReturn + sBuffer
                        Tcp Send iCurrentSocket, sReturn

                     '----------- UNKNOWN instruction
                     Case Else
                        LogEvent "UNKNOWN INSTRUCTION:" + Str$(rIn.iCommand)
                        DisplayEvent "Unknown Instruction:" + Str$(rIn.iCommand)
                        rOut.iResult = 0
                        rOut.iFile = 0
                        rOut.iDataLen = 0
                        sReturn = Space$(Len(rOut))
                        Lset sReturn = rOut
                        Tcp Send iCurrentSocket, sReturn

                  End Select

               End If

            Case %FD_CLOSE
               For i = 1 To %MAX_CONNECTIONS
                  If FileAttr(gSock(i), 2) = CbWParam Then
                     Tcp Close gSock(i)
                     gSock(i) = %INVALID_SOCKET
                     gActive = gActive - 1
                     DisplayEvent "Socket Closed"
                     Exit For
                  End If
               Next i

            Case Else
               DisplayEvent "Socket event received - %TCP_CONNECT LOWRD(lparam) =" + Str$(LoWrd(CbLParam))

         End Select
         Function = 1

      Case %WM_DESTROY
         Tcp Close hSock
         Print #gLog, "----------------------------------------------"
         Print #gLog, "SHUT DOWN " + Date$ + "  " + Time$
         Print #gLog, "  Active Clients:" + Str$(gActive)
         Print #gLog, "      Total Hits:" + Str$(gHits)
         Print #gLog, "**********************************************"
         Close #gLog

   End Select

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Callback Function StopButton

   Dialog End gDlgMain, 0
   Function = 1

End Function

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Function PbMain As Long

   Dim i As Long
   Dim ipAddress As Long
   Dim zText As Asciiz * 100

   gPort = %DEFAULT_PORT

   Host ADDR "" To ipAddress

   '- Open the log file
   On Error Resume Next
   gLog = FreeFile
   Open "rserver.log" For Append As #gLog
   If Err Then
      MsgBox "Unable to create log file. Error =" + Str$(Err)
   Else
      Print #gLog, ""
      Print #gLog, "**********************************************"
      Print #gLog, "START UP " + Date$ + "  " +Time$
      Print #gLog, "      IP Address: " + FormatIP(ipAddress)
      Print #gLog, "----------------------------------------------"
   End If

   '- These are our connections. Fill up the list with
   '  invalid connections.
   '
   ReDim gSock(1 To %MAX_CONNECTIONS) As Long
   For i = 1 To %MAX_CONNECTIONS
      gSock(i) = %INVALID_SOCKET
   Next i

   '- Create the main screen.
   Dialog New 0, "Binary Data Server on Port " + Format$(%DEFAULT_PORT),,, 200, 200, %WS_MINIMIZEBOX Or %WS_CAPTION Or %WS_SYSMENU, 0 To gDlgMain

   Control Add label, gDlgMain, -1, "Server IP", 17, 10, 40, 8, %SS_RIGHT
   Control Add label, gDlgMain, -1, "Port", 17, 25, 40, 8, %SS_RIGHT
   Control Add label, gDlgMain, -1, "Started", 17, 40, 40, 8, %SS_RIGHT
   Control Add label, gDlgMain, -1, "Total Hits", 17, 55, 40, 8, %SS_RIGHT
   Control Add label, gDlgMain, -1, "Active Clients", 17, 70, 40, 8, %SS_RIGHT
   Control Add label, gDlgMain, -1, "Last Action", 17, 85, 40, 8, %SS_RIGHT

   Control Add label, gDlgMain, %labIP, FormatIP(ipAddress), 65, 10, 80, 8, %SS_LEFT
   Control Add label, gDlgMain, %labPort, Format$(gPort), 65, 25, 80, 8, %SS_LEFT
   Control Add label, gDlgMain, %labDate, Date$ + "   " + Time$, 65, 40, 80, 8, %SS_LEFT
   Control Add label, gDlgMain, %labHits, "0", 65, 55, 80, 8, %SS_LEFT
   Control Add label, gDlgMain, %labActive, "0", 65, 70, 80, 8, %SS_LEFT
   Control Add label, gDlgMain, %labAction, "", 65, 85, 135, 8, %SS_LEFT

   Control Add Button, gDlgMain, %IDCANCEL, "&Stop", 150, 177, 40, 15, 0 Call StopButton

   Dialog Show Modal gDlgMain Call DlgProc

   '- Make sure to clean up any open sockets
   For i = 1 To %MAX_CONNECTIONS
      If gSock(i) = %INVALID_SOCKET Then
         Tcp Close gSock(i)
      End If
   Next i

   '- Close any open files
   Close

End Function

'
